Redmine - Defect #15716

Scraped emails include CSS from HTML emails
2013-12-16 15:34 - Deoren Moor

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Email receiving Estimated time: 0.00 hour
Target version: 3.1.0

Resolution: Fixed Affected version: 241
Description

I'm not sure how many others are encountering this behavior, but when replying to an email notification (and making sure to remove
all text from the body) the CSS for HTML emails is included as if it were written by the user. In this particular case | responded to a
notification using the default mail client from iOS 7.

Example reply:
Sure, that will work.

body {

font-family: Verdana, sans-serif;
font-size: 0.8em;

color:#484848;

}

hl, h2, h3 { font-family: "Trebuchet MS", Verdana, sans-serif; margin: Opx; }
hl { font-size: 1.2em; }

h2, h3 { font-size: 1l.lem; }

a, a:link, a:visited { color: #2A5685;}
a:hover, a:active { color: #c6lala; }
a.wiki-anchor { display: none; }
fieldset.attachments {border-width: 1lpx 0 0 0;}
hr {

width: 100%;

height: 1lpx;

background: f#ccc;

border: 0;

}

span.footer {

font-size: 0.8em;

font-style: italic;

}

Our environment:

Redmine version 2.4.1.stable.12325

Ruby version 1.8.7-p352 (2011-06-30) [1686-1inux]
Rails version 3.2.15

Environment production

Database adapter My SQL

Related issues:
Related to Redmine - Defect #19740: "Truncate emails after one of these lines... Closed
Related to Redmine - Defect #20311: Task from Email - Styles in task text Closed

Associated revisions

Revision 14315 - 2015-06-16 20:23 - Jean-Philippe Lang
Remove style tags from html body (#15716).

History

#1 - 2014-02-27 03:40 - Deoren Moor
Is there any additional information that | can provide? Any tips/config changes that | can try?
Thanks.

#2 - 2014-07-06 14:23 - Go MAEDA

| cannot reproduce with Redmine 2.5.1/i0S 7.1.1. Does this problem still occur?
#3 - 2014-07-06 17:35 - Deoren Moor
Hi,

Thanks for the reply. Yes, it occurs every time | send an email from an iOS device. | have not yet tested with the newly released Redmine 2.5.2, but |
will do so and post back with my results.

#4 - 2014-07-06 18:16 - Deoren Moor
Deoren Moor wrote:

Yes, it occurs every time | send an email from an iOS device.

To be clear, my OP had the key ingredient:
| responded to a notification using the default mail client from iOS 7.

| did not see the behavior when sending in the initial report, but when replying to an email that is when | noticed it. It's also worth noting that we have
our Redmine installation configured to send HTML emails and not plaintext emails.
It probably doesn't make a difference, but | sent the test email and test reply from an iOS 7.1.2 device.
#5 - 2014-07-07 14:31 - Go MAEDA
- File reply_to_the_notification_15176.png added
No problem with iOS 7.1.2 and notification from www.redmine.org. What happens when you reply to the notification from www.redmine.org?
Issue #15716 has been updated by
Deoren Moor.
#6 - 2014-07-08 05:27 - Deoren Moor

I just replied, but | noticed that the address | was replying to is 'noreply@redmine.org', so | suspect it will not end up here.

Is there any additional information | can supply about our setup?

#7 - 2014-07-08 17:37 - Deoren Moor
Sounds like someone else is having the problem too (maybe they just posted to the wrong ticket): #10929#note-4

#8 - 2014-07-08 18:08 - Deoren Moor

Digging back through our Redmine system | found that the earliest example of this happening is June 24, 2013. We would have been running
whatever Redmine version was current at the time. If I'm not mistaken, that would be version 2.3.1.

#9 - 2015-04-29 18:15 - Deoren Moor

Note: this is still a problem as of Redmine 3.0.2. We see it often for current versions of Mac OS X and iOS. I'm still using iOS 7 on a work device, and
| see the behavior with it as well.

#10 - 2015-04-29 18:29 - Toshi MARUYAMA

- Related to Defect #19740: "Truncate emails after one of these lines" setting is not working added

#11 - 2015-06-16 01:51 - Deoren Moor
Still a problem as of Redmine 3.0.3 + back-ported changes in r14313.

#12 - 2015-06-16 10:59 - Jean-Philippe Lang
- File reply_from_ios.png added

Works fine for me when replying from iOS 8.3 with current trunk (including r14313), here is what | get in Redmine:

Description
Replying to a Redmine notification from i0S 8.3

Envoye de mon iIPhonea

HTML-ortly emails (r14313). HTML processing was moved from the MailHandler to the
it to wiki 5] X,

WIKT SyTia

sofved processing issuas with Apple Mail emails (#15716) from Mac OS5 X and i

(=]
L]

~count

Can you send a test reply to my email address (jp_lan ahoo.fr) so | can try to reproduce?

#13 - 2015-06-16 11:07 - Jean-Philippe Lang
- File html_reply_from_ios.png added

My reply from iOS contains a plain text part and a html part so Redmine chooses the plain text part, with the result above.
If I manually remove the plain text part before submitting the email to Redmine, here is was | get:
mailto:noreply@redmine.org
https://www.redmine.org/issues/10929#note-4
https://www.redmine.org/versions/71
https://www.redmine.org/projects/redmine/repository/svn/revisions/14313
https://www.redmine.org/projects/redmine/repository/svn/revisions/14313
mailto:jp_lang@yahoo.fr

Description = Citer
Replying to a Redmine notification from i0S 8.3

Envoyé de mon iPhone

Le 16 juin 2015 & 01:54, noreply @redmine.org a &crit :

body { font-family: verdana, sans-serif; font-gize: 0.8em; color: #484848;}h1, h2, h3 { font-family: “Trebuchet MS”, Verdana, sans-serif;
margn: Opx; thi { font-size: 1.2em; }h2, h3 { font-size: 1.1em; }a, a:link, aswsited { color: # 24 tachover, a:active { color: #o61ala;

}a.wiki-anchor { display: none; Hieldset.attachments {border-width: 1px 0 0 0; }hr { width: 100%; height: 1px: background: #ccc; border:
0; span.footer { font-size: 0.8em; font-style: talc; }lssue £16962 has been updated by Deoren Moor.

lean-Philippe Lang wrote:

Loofah is now used for processing HTML-only emails (ri4313). HTML processing was moved from the MailHandler to the text formatter so we
can convert it to wiki syntax.

Should the changes have also solved processing issues with Apple Mail emails (#15716) from Mac OS5 X and 057

Feature #16962: Better handle html-only emails

Author: Felix Schafer
status: Closed

Priority: NMormal
Category: Email receiving
Resolubion: Fixed

Currantly html-only emails are handled by just removing all html tags, this causes really munched together formatting, because html doesn't
rely on newlines for formatting, and styles present in the head are also just passad aver

Files 16962.patch (2.21 KB)

16962.2.patch (2.59 KB)

Snip20141227_1.png (28.6 KB)

Test Emaill.msg (21 KB)

You have received this notification because you have either subscribed to it, or are involved in it.
To change yvour notiication preferences, please dick hera: J http://www.redmmne.org/my/account

#14 - 2015-06-16 15:46 - Deoren Moor

Jean-Philippe Lang wrote:

Works fine for me when replying from iOS 8.3 with current trunk (including r14313), here is what | get in Redmine:

Can you send a test reply to my email address (jp_lan hoo.fr) so | can try to reproduce?

Thanks for the reply and for testing.

| was a bit confused when | saw your example, so | took a closer look at Apple Mail on my iPhone 4 w/iOS 7.1.2 and found that the Increase Quote
Level was set to Off. | tried with it both Off and On and got the same results. This is with me doing nothing more than adding my reply at the top and
hitting send.

I'm going to forward the emails as an attachment (from Outlook) to the personal email address you've listed. If you'd rather have them in a different
format please let me know and I'll provide them in whichever format you wish. Thanks again for looking into this.

#15 - 2015-06-16 15:51 - Deoren Moor
- File redmine_3.0.3+r14313 _replies_from_iPhone4 iOS_7.1.2.png added

Just sent two samples, one with Increase Quote Level On and another with it set to Off. Both appear to give the same results:

~500
In the past the CSS wasn't collapsed and looked more like what was shown in the OP.

#16 - 2015-06-16 20:24 - Jean-Philippe Lang
- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 3.1.0

- Resolution set to Fixed

This should be fixed by r14315, style tags inside html body were not removed. Please reopen if you still experience the problem after this.

#17 - 2015-07-15 02:40 - Toshi MARUYAMA
- Related to Defect #20311: Task from Email - Styles in task text added

#18 - 2015-07-15 14:46 - Dmitriy Ermakov
https://www.redmine.org/attachments/13796
Good day!
I am from task http://www.redmine.org/issues/20311

| apply r14315 (http://www.redmine.org/projects/redmine/repository/revisions/14315).

But now i receive styles in my tasks(
P {margin-top:0;margin-bottom:0;}
test

#19 - 2015-07-15 15:18 - Toshi MARUYAMA

Dmitriy Ermakov wrote:

| apply r14315 (http://www.redmine.org/projects/redmine/repository/revisions/14315).

But now i receive styles in my tasks(
P {margin-top:0;margin-bottom:0;}

test

You need to apply r14313 at first.

Files

reply_to_the_notification_15176.png 109 KB 2014-07-07 Go MAEDA

reply_from_ios.png 106 KB 2015-06-16 Jean-Philippe Lang

html_reply_from_ios.png 130 KB 2015-06-16 Jean-Philippe Lang

redmine_3.0.3+r14313_replies_from_iPhone4_iOS_7.1.2.png 51.1 KB 2015-06-16 Deoren Moor
